org.apache.tinkerpop.gremlin.process.traversal.step.map

## Class MatchStep<S,E>

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep<S,E>
  - - org.apache.tinkerpop.gremlin.process.traversal.step.util.ComputerAwareStep<S,Map<String,E>>
    - - org.apache.tinkerpop.gremlin.process.traversal.step.map.MatchStep<S,E>

- All Implemented Interfaces:
    Serializable, AutoCloseable, Cloneable, Iterator<Traverser.Admin<Map<String,E>>>, Step<S,Map<String,E>>, GraphComputing, PathProcessor, Scoping, TraversalParent

      public final class MatchStep<S,E>
      extends ComputerAwareStep<S,Map<String,E>>
      implements TraversalParent, Scoping, PathProcessor

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)
  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `MatchStep.CountMatchAlgorithm`
    `static class` | `MatchStep.GreedyMatchAlgorithm`
    `static class` | `MatchStep.Helper`
    `static interface` | `MatchStep.MatchAlgorithm`
    `static class` | `MatchStep.MatchEndStep`
    `static class` | `MatchStep.MatchStartStep`
    `static class` | `MatchStep.TraversalType`

    - ### Nested classes/interfaces inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.ComputerAwareStep

      `ComputerAwareStep.EndStep<S>`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `Scoping.KeyNotFoundException, Scoping.Variable`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `PathProcessor.ElementRequirement`

  - ### Field Summary

    - ### Fields inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `id, labels, nextEnd, nextStep, previousStep, starts, traversal, traverserStepIdAndLabelsSetByChild`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MatchStep(Traversal.Admin traversal, ConnectiveStep.Connective connective, Traversal... matchTraversals)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addGlobalChild(Traversal.Admin<?,?> globalChildTraversal)`
    `MatchStep<S,E>` | `clone()` Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication.
    `protected Iterator<Traverser.Admin<Map<String,E>>>` | `computerAlgorithm()`
    `ConnectiveStep.Connective` | `getConnective()`
    `List<Traversal.Admin<Object,Object>>` | `getGlobalChildren()`
    `Set<String>` | `getKeepLabels()`
    `MatchStep.MatchAlgorithm` | `getMatchAlgorithm()`
    `Set<String>` | `getMatchEndLabels()`
    `Set<String>` | `getMatchStartLabels()`
    `Set<TraverserRequirement>` | `getRequirements()` Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly.
    `Set<String>` | `getScopeKeys()` Get the labels that this scoping step will access during the traversal
    `int` | `hashCode()`
    `void` | `removeGlobalChild(Traversal.Admin<?,?> globalChildTraversal)`
    `void` | `reset()` Reset the state of the step such that it has no incoming starts.
    `void` | `setDedupLabels(Set<String> labels)`
    `void` | `setKeepLabels(Set<String> keepLabels)`
    `void` | `setMatchAlgorithm(Class<? extends MatchStep.MatchAlgorithm> matchAlgorithmClass)`
    `void` | `setTraversal(Traversal.Admin<?,?> parentTraversal)` Set the `Traversal` that this step is contained within.
    `protected Iterator<Traverser.Admin<Map<String,E>>>` | `standardAlgorithm()`
    `String` | `toString()`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.ComputerAwareStep

      `onGraphComputer, processNextStart`

    - ### Methods inherited from class org.apache.tinkerpop.gremlin.process.traversal.step.util.AbstractStep

      `addLabel, addStart, addStarts, equals, getId, getLabels, getNextStep, getPreviousStep, getStarts, getTraversal, hasNext, hasStarts, isTraverserStepIdAndLabelsSetByChild, next, prepareTraversalForNextStep, removeLabel, setId, setNextStep, setPreviousStep`

    - ### Methods inherited from class java.lang.Object

      `finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.TraversalParent

      `addLocalChild, asStep, close, getLocalChildren, getSelfAndChildRequirements, integrateChild, removeLocalChild, replaceLocalChild`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.Scoping

      `getNullableScopeValue, getSafeScopeValue, getScopeValue`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.PathProcessor

      `getMaxRequirement, processTraverserPathLabels`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.step.GraphComputing

      `atMaster, atMaster`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.traversal.Step

      `equals`

    - ### Methods inherited from interface java.util.Iterator

      `forEachRemaining, remove`

- - ### Constructor Detail

    - #### MatchStep

          public MatchStep(Traversal.Admin traversal,
                           ConnectiveStep.Connective connective,
                           Traversal... matchTraversals)

  - ### Method Detail

    - #### getConnective

          public ConnectiveStep.Connective getConnective()

    - #### addGlobalChild

          public void addGlobalChild(Traversal.Admin<?,?> globalChildTraversal)

      Specified by:
        `addGlobalChild` in interface `TraversalParent`

    - #### removeGlobalChild

          public void removeGlobalChild(Traversal.Admin<?,?> globalChildTraversal)

      Specified by:
        `removeGlobalChild` in interface `TraversalParent`

    - #### getGlobalChildren

          public List<Traversal.Admin<Object,Object>> getGlobalChildren()

      Specified by:
        `getGlobalChildren` in interface `TraversalParent`

    - #### setKeepLabels

          public void setKeepLabels(Set<String> keepLabels)

      Specified by:
        `setKeepLabels` in interface `PathProcessor`

    - #### getKeepLabels

          public Set<String> getKeepLabels()

      Specified by:
        `getKeepLabels` in interface `PathProcessor`

    - #### getMatchEndLabels

          public Set<String> getMatchEndLabels()

    - #### getMatchStartLabels

          public Set<String> getMatchStartLabels()

    - #### getScopeKeys

          public Set<String> getScopeKeys()

      Description copied from interface: `Scoping`
      Get the labels that this scoping step will access during the traversal
      Specified by:
        `getScopeKeys` in interface `Scoping`
      Returns:
        the accessed labels of the scoping step

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `AbstractStep<S,Map<String,E>>`

    - #### reset

          public void reset()

      Description copied from interface: `Step`
      Reset the state of the step such that it has no incoming starts. Internal states are to be reset, but any sideEffect data structures are not to be recreated.
      Specified by:
        `reset` in interface `Step<S,Map<String,E>>`
      Overrides:
        `reset` in class `ComputerAwareStep<S,Map<String,E>>`

    - #### setMatchAlgorithm

          public void setMatchAlgorithm(Class<? extends MatchStep.MatchAlgorithm> matchAlgorithmClass)

    - #### getMatchAlgorithm

          public MatchStep.MatchAlgorithm getMatchAlgorithm()

    - #### clone

          public MatchStep<S,E> clone()

      Description copied from interface: `Step`
      Cloning is used to duplicate steps for the purpose of traversal optimization and OLTP replication. When cloning a step, it is important that the steps, the cloned step is equivalent to the state of the step when `Step.reset()` is called. Moreover, the previous and next steps should be set to `EmptyStep`.
      Specified by:
        `clone` in interface `Step<S,Map<String,E>>`
      Overrides:
        `clone` in class `ComputerAwareStep<S,Map<String,E>>`
      Returns:
        The cloned step

    - #### setTraversal

          public void setTraversal(Traversal.Admin<?,?> parentTraversal)

      Description copied from interface: `Step`
      Set the `Traversal` that this step is contained within.
      Specified by:
        `setTraversal` in interface `Step<S,Map<String,E>>`
      Overrides:
        `setTraversal` in class `AbstractStep<S,Map<String,E>>`
      Parameters:
        `parentTraversal` - the new traversal for this step

    - #### setDedupLabels

          public void setDedupLabels(Set<String> labels)

    - #### standardAlgorithm

          protected Iterator<Traverser.Admin<Map<String,E>>> standardAlgorithm()
                                                                        throws NoSuchElementException

      Specified by:
        `standardAlgorithm` in class `ComputerAwareStep<S,Map<String,E>>`
      Throws:
        `NoSuchElementException`

    - #### computerAlgorithm

          protected Iterator<Traverser.Admin<Map<String,E>>> computerAlgorithm()
                                                                        throws NoSuchElementException

      Specified by:
        `computerAlgorithm` in class `ComputerAwareStep<S,Map<String,E>>`
      Throws:
        `NoSuchElementException`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `AbstractStep<S,Map<String,E>>`

    - #### getRequirements

          public Set<TraverserRequirement> getRequirements()

      Description copied from interface: `Step`
      Provide the necessary `TraverserRequirement` that must be met by the traverser in order for the step to function properly. The provided default implements returns an empty set.
      Specified by:
        `getRequirements` in interface `Step<S,Map<String,E>>`
      Returns:
        the set of requirements

Copyright © 2013–2021 Apache Software Foundation. All rights reserved.